/*
   tuner.cpp

   ZORAN ZR36120 module driver.
   Copyright (C) 1997  Vincent Labie (try ivsparis@pratique.fr with
				      for Vincent Labie in the suject)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include	"video.h"

extern	int		Err;
extern	int		fd;
extern	int		Input;
extern	int		Standart;

int		indexfreq	=67; //M6 //61;// FR3 //
unsigned long	freqinc		=0x00000001;
unsigned long	freq;

typedef struct
	{
	const char		name[4];
	const float		frq;
	}	CHANNEL;

CHANNEL			TabChannel[]=
//			CCIR Cable
	{
	{ "E2", 48.25},{ "E3", 55.25},{ "E4", 62.25},{"S01", 69.25},{"S02", 76.25},{"S03", 83.25},
	{ "S1",105.25},{ "S2",112.25},{ "S3",119.25},{ "S4",126.25},{ "S5",133.25},{ "S6",140.25},
	{ "S7",147.25},{ "S8",154.25},{ "S9",161.25},{"S10",168.25},{ "E5",175.25},{ "E6",182.25},
	{ "E7",189.25},{ "E8",196.25},{ "E9",203.25},{"E10",210.25},{"E11",217.25},{"E12",224.25},
	{"S11",231.25},{"S12",238.25},{"S13",245.25},{"S14",252.25},{"S15",259.25},{"S16",266.25},
	{"S17",273.25},{"S18",280.25},{"S19",287.25},{"S20",294.25},{"S21",303.25},{"S22",311.25},
	{"S23",319.25},{"S24",327.25},{"S25",335.25},{"S26",343.25},{"S27",351.25},{"S28",359.25},
	{"S29",367.25},{"S30",375.25},{"S31",383.25},{"S32",391.25},{"S33",399.25},{"S34",407.25},
	{"S35",415.25},{"S36",423.25},{"S37",431.25},{"S38",439.25},{"S39",447.25},{"S40",455.25},
	{"S41",463.25},

//			CCIR BG
	{  "2", 48.25},{  "3", 55.25},{  "4", 62.25},{  "5",175.25},{  "6",182.25},{  "7",189.25},
	{  "8",196.25},{  "9",203.25},{ "10",210.25},{ "11",217.25},{ "12",224.25},{ "21",471.25},
	{ "22",479.25},{ "23",487.25},{ "24",495.25},{ "25",503.25},{ "26",511.25},{ "27",519.25},
	{ "28",527.25},{ "29",535.25},{ "30",543.25},{ "31",551.25},{ "32",559.25},{ "33",567.25},
	{ "34",575.25},{ "35",583.25},{ "36",591.25},{ "37",599.25},{ "38",607.25},{ "39",615.25},
	{ "40",623.25},{ "41",631.25},{ "42",639.25},{ "43",647.25},{ "44",655.25},{ "45",663.25},
	{ "46",671.25},{ "47",679.25},{ "48",687.25},{ "49",695.25},{ "50",703.25},{ "51",711.25},
	{ "52",719.25},{ "53",727.25},{ "54",735.25},{ "55",743.25},{ "56",751.25},{ "57",759.25},
	{ "58",767.25},{ "59",775.25},{ "60",783.25},{ "61",791.25},{ "62",799.25},{ "63",807.25},
	{ "64",815.25},{ "65",823.25},{ "66",831.25},{ "67",839.25},{ "68",847.25},{ "69",855.25},

//			FR channel
	{ "FA", 47.75},{ "FB", 55.75},{"FC1", 60.50},{ "FC", 63.75},{ "F1",176.00},{ "F2",184.00},
	{ "F3",192.00},{ "F4",200.00},{ "F5",208.00},{ "F6",216.00},
	{   "", -1.0}
	};

/*************************************************************************************************/
/*************************************************************************************************/
void		ChangeChannel()
{
	ZR_I2C_ACCESS		ZRI2CAccess;
	u_char			TabByte[4];

	float		freq=TabChannel[indexfreq].frq;
	long		frq;
	float		PictureCarrier=	/*33.95*/38.90;	/* L: 38.90, L':33.95, B/G: 38.90 */

	frq=(long)((float)(freq+PictureCarrier)*16.0+.5);
	u_char			Pd1=frq/256; Pd1&=0x7f;
	u_char			Pd2=frq;

	u_char			CP=0;			/* 1=fast tuning, 0=slow */
	u_char			T2=0, T1=0, T0=1;	/* normal mode*/
	u_char			RSA=0, RSB=1;		/* RSA=X,RSB=0 => 50khz */
							/* RSA=0,RSB=1 => 31.25khz slow search */
							/* RSA=1,RSB=1 => 62.5khz normal search */
	u_char			OS=0;			/* normal pump op */
	u_char			Cb1=0x80+CP*0x40+T2*0x20+T1*0x10+T0*0x08+RSA*0x04+RSB*0x02+OS*0x01;

	u_char			P0=0, P1=1;		/* P0=0; P1=0 for FI1216 */
							/* P0=1; P1=1 for FI1216MF band LL  38.90 */
							/* P0=0; P1=1 for FI1216MF band LL' 33.95 */
							/* P0=1; P1=0 for FI1216MF band B/G 48.90 */
	u_char			P2=1;	// dirty philips! one loosed week to find that this one was wrong in the doc!
					// humm... perhaps my tuner is not a philips anyway :)
	u_char			P3=0;			/* ? */
	u_char			P4,P5,P6,P7;
	if ((float)frq>455.25*16.)		{ P4=1; P5=1; P6=0; P7=0; } // high band
	else	if ((float)frq>175.25*16.)	{ P4=1; P5=0; P6=0; P7=1; } // mid band
		else				{ P4=0; P5=1; P6=0; P7=1; } // low band
	u_char			Cb2=P7*0x80+P6*0x40+P5*0x20+P4*0x10+P3*0x08+P2*0x04+P1*0x02+P0*0x01;

	printf("indexfreq=%i, channel=%s, channelfreq=%f, frq=0x%04X, freq=%f\n",
		indexfreq,TabChannel[indexfreq].name,TabChannel[indexfreq].frq,frq,freq);

	ZRI2CAccess.I2CAdr	=0xc0;
	ZRI2CAccess.I2CSubAdr	=-1;
	ZRI2CAccess.NbByte	=sizeof(TabByte);
	ZRI2CAccess.TabByte	=TabByte;

	TabByte[0]=Pd1; TabByte[1]=Pd2; TabByte[2]=Cb1; TabByte[3]=Cb2;
	if ((Err=ioctl(fd,ZORAN_I2C_WRITE,&ZRI2CAccess))!=ZRI2CAccess.NbByte)
		{ printf("ioctl ZORAN_I2C_READ %i.\n",Err); perror("ioctl"); }
	printf("send 0x%08X\n",(uint)((uint)TabByte[0]<<24)+((uint)TabByte[1]<<16)+((uint)TabByte[2]<<8)+(uint)TabByte[3]);

	indexfreq++;
	if (TabChannel[indexfreq].frq<0) indexfreq=0;

	ZRI2CAccess.I2CAdr	=0xc1;
	ZRI2CAccess.I2CSubAdr	=-1;
	ZRI2CAccess.NbByte	=1;
	ZRI2CAccess.TabByte	=TabByte;

	for (int retry=0;retry<100;retry++)
		{
		if ((Err=ioctl(fd,ZORAN_I2C_READ,&ZRI2CAccess))!=ZRI2CAccess.NbByte)
			{ printf("ioctl ZORAN_I2C_READ %i.\n",Err); perror("ioctl"); continue; }
		if (TabByte[0]&0x40)
			{
			printf("tuner pll locked\n");
			break;
			}
		else	printf("tuner pll not locked\n");
		usleep(1000);
		}
	printf("read tuner status %i\n",TabByte[0]);

	char *		TabszStd[]={"ZORAN_AUTO","ZORAN_NTSC","ZORAN_PAL","ZORAN_SECAM","ZORAN_BW60HZ","ZORAN_BW50HZ"};
	if ((Err=ioctl(fd,Input,Standart))<0)
		{ printf("ioctl %i => %i.\n",Input,Err); perror("ioctl"); }
	else	printf("Set standart %s, stat=0x%02X, 0x%08X\n",TabszStd[(Err&0xffff)-ZORAN_AUTO],Err>>16,Err);
}

